;/*************************************************************************
;** funct-2.4      (command interpreter - funct)                          **
;** graph.h :                                                             **
;** Copyright (C) 2000  Jean-Marc Drezet                                  **
;**                                                                       **
;**  This library is free software; you can redistribute it and/or        **
;**  modify it under the terms of the GNU Library General Public          **
;**  License as published by the Free Software Foundation; either         **
;**  version 2 of the License, or (at your option) any later version.     **
;**                                                                       **
;**  This library is distributed in the hope that it will be useful,      **
;**  but WITHOUT ANY WARRANTY; without even the implied warranty of       **
;**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    **
;**  Library General Public License for more details.                     **
;**                                                                       **
;**  You should have received a copy of the GNU Library General Public    **
;**  License along with this library; if not, write to the Free           **
;**  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   **
;**                                                                       **
;** Please mail any bug reports/fixes/enhancements to me at:              **
;**      drezet@math.jussieu.fr                                           **
;** or                                                                    **
;**      Jean-Marc Drezet                                                 **
;**      Institut de Mathematiques                                        **
;**      UMR 7586 du CNRS                                                 **
;**      173, rue du Chevaleret                                           **
;**      75013 Paris                                                      **
;**      France                                                           **
;**                                                                       **
;**************************************************************************/


#ifndef _GRAPH
#define _GRAPH

#include <interp.h>
#include <g2.h>
#include <g2_PS.h>
#ifdef __GGILIB_X11
#include <ggi/ggi.h>
extern ggi_color       white,
                       black,
                      *ggi_col;
extern int             _nb_ggi_graph,
                       _nb_ggi_color,
                       ggi_line_width;
extern ggi_visual_t    ggi_vis;
extern ggi_pixel       color_ggi,
                       color_white,
                       color_black;
#define _FUNCT_OPEN_X11       _FUNCT_ggi_open_X11
#define _FUNCT_PLOT           _FUNCT_ggi_plot
#define _FUNCT_SET_LINE_WIDTH _FUNCT_ggi_set_line_width
#define _FUNCT_LINE_TO        _FUNCT_ggi_line_to
#define _FUNCT_PEN            _FUNCT_ggi_pen
#define _FUNCT_MOVE           _FUNCT_ggi_move
#define _FUNCT_SET_DASH       _FUNCT_ggi_set_dash
#define _FUNCT_DRAW_STRING    _FUNCT_ggi_draw_string
#define _FUNCT_CLEAR          _FUNCT_ggi_clear
#define _FUNCT_INK            _FUNCT_ggi_ink
#define _FUNCT_CLOSE          _FUNCT_ggi_close
#define _NB_GGI_GRAPH_MAX 1000
#define _NB_GGI_COLOR_MAX 1000
int     _FUNCT_ggi_open_X11();
void    _FUNCT_ggi_plot(int, int, double, double, float *);
void    _FUNCT_ggi_set_line_width(int, int, double, float *);
void    _FUNCT_ggi_line_to(int, int, double, double, float *);
void    _FUNCT_ggi_pen(int, int, int);
void    _FUNCT_ggi_move(int, int, double, double, float *);
void    _FUNCT_ggi_set_dash(int, int, int, double *, float *);
void    _FUNCT_ggi_draw_string(int, int, double, double, char *, float *);
void    _FUNCT_ggi_clear(int iw, int i0);
int     _FUNCT_ggi_ink(int, int, double, double, double, int);
void    _FUNCT_ggi_close(int, int);
#endif
#ifdef __ALLEGROLIB_X11
extern int             _nb_allegro_color;
extern int            *allegro_col;
#include <allegro.h>
#define _FUNCT_OPEN_X11       _FUNCT_allegro_open_X11
#define _FUNCT_PLOT           _FUNCT_allegro_plot
#define _FUNCT_SET_LINE_WIDTH _FUNCT_allegro_set_line_width
#define _FUNCT_LINE_TO        _FUNCT_allegro_line_to
#define _FUNCT_PEN            _FUNCT_allegro_pen
#define _FUNCT_MOVE           _FUNCT_allegro_move
#define _FUNCT_SET_DASH       _FUNCT_allegro_set_dash
#define _FUNCT_DRAW_STRING    _FUNCT_allegro_draw_string
#define _FUNCT_CLEAR          _FUNCT_allegro_clear
#define _FUNCT_INK            _FUNCT_allegro_ink
#define _FUNCT_CLOSE          _FUNCT_allegro_close
#define _NB_GRX_GRAPH_MAX 1000
#define _NB_GRX_COLOR_MAX 1000
int     _FUNCT_allegro_open_X11();
void    _FUNCT_allegro_plot(int, int, double, double, float *);
void    _FUNCT_allegro_set_line_width(int, int, double, float *);
void    _FUNCT_allegro_line_to(int, int, double, double, float *);
void    _FUNCT_allegro_pen(int, int, int);
void    _FUNCT_allegro_move(int, int, double, double, float *);
void    _FUNCT_allegro_set_dash(int, int, int, double *, float *);
void    _FUNCT_allegro_draw_string(int, int, double, double, char *, float *);
void    _FUNCT_allegro_clear(int iw, int i0);
int     _FUNCT_allegro_ink(int, int, double, double, double, int);
void    _FUNCT_allegro_close(int, int);
#endif
#include <g2_GIF.h>


/*--------------------------------------------------------------------
----------------------------------------------------------------------
    Function prototypes
----------------------------------------------------------------------
--------------------------------------------------------------------*/

/*====================================================================
                        graphcmd.c
====================================================================*/
int     defgraph_PS_cmd(int argc, char *argv[]);
int     graph_plot_cmd(int argc, char *argv[]);
int     graph_lineto_cmd(int argc, char *argv[]);
int     clear_graph_cmd(int argc, char *argv[]);
int     fixcolor_cmd(int argc, char *argv[]);
int     setcolor_cmd(int argc, char *argv[]);
int     fixframe_cmd(int argc, char *argv[]);
int     setframe_cmd(int argc, char *argv[]);
int     clip_line(float, float, float, float, float *, float *);
int     graph_plot_c_cmd(int argc, char *argv[]);
int     graph_lineto_c_cmd(int argc, char *argv[]);
int     set_clip_cmd(int argc, char *argv[]);
/*--------------------------------------------------------------------
----------------------------------------------------------------------
--------------------------------------------------------------------*/




extern int _GRAPH_MESS,
           _GRAPH_PS,
           _GRAPH_COL,
           _GRAPH_FRAM,
           _GRAPH_X,
           _GRAPH_Y;
extern pfi proc_graph[];

typedef struct _CLIP
{
    float       xinf_clip;
    float       xsup_clip;
    float       yinf_clip;
    float       ysup_clip;
} funct_clip;

float       _GRAPH_xx[20];
extern int  ind0k_gr;

#ifdef _HAVE_THREADS
pthread_mutex_t         mutex_g2;
#endif

#endif


